package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.SeguradoraEmpresaDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.SeguradoraEmpresa;
import com.rjconsultores.ventaboletos.service.SeguradoraEmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("seguradoraEmpresaService")
public class SeguradoraEmpresaServiceImpl implements SeguradoraEmpresaService {

    @Autowired
    private SeguradoraEmpresaDAO seguradoraEmpresaDAO;

    public List<SeguradoraEmpresa> obtenerTodos() {
        return seguradoraEmpresaDAO.obtenerTodos();
    }

    public SeguradoraEmpresa obtenerID(Integer id) {
        return seguradoraEmpresaDAO.obtenerID(id);
    }

    public boolean existe(Empresa empresa, String serie){
    	return seguradoraEmpresaDAO.existe(empresa, serie);
    }
    
    @Transactional
    public SeguradoraEmpresa suscribir(SeguradoraEmpresa entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);
        
        return seguradoraEmpresaDAO.suscribir(entidad);
    }

    @Transactional
    public SeguradoraEmpresa actualizacion(SeguradoraEmpresa entidad) {
        return seguradoraEmpresaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(SeguradoraEmpresa entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);
        
        seguradoraEmpresaDAO.borrar(entidad);
    }
}
